# rtio-nmigen

Formally verified implementation of the ARTIQ RTIO core in nMigen

## Progress

- Devise a suitable migration strategy for `artiq.gateware.rtio` from Migen to nMigen
- [x] Implement the core in nMigen
- - [x] `rtio.cri` (`Interface` and `CRIDecoder` only)
- - [x] `rtio.rtlink`
- - [x] `rtio.sed.layouts`
- - [x] `rtio.sed.output_network`
- - [x] `rtio.sed.output_driver`
- [ ] Add suitable assertions for verification (BMC / unbounded proof?)

## License

Copyright (C) 2020 M-Labs Limited.

[LGPLv3](./LICENSE) or any later version
